Package com.sas.metadata.remote

# Interface TCPIPConnection

All Superinterfaces:
  `CMetadata`, `Connection`, `ContentLocation`, `DeployedDataPackage`, `MdObjectBase`, `MdObjectBaseUtil`, `MdObjectBaseXML`, `OpenClientConnection`, `PrimaryType`, `Remote`, `Root`

public interface TCPIPConnection extends OpenClientConnection
Contains information for making a TCP/IP connection to a server.

Attributes of TCPIPConnection are:

- `HostName`
- `Service`
- `Port`

Associations of TCPIPConnection are:

## Usage

To create an instance of this TCPIPConnection, use the `factory` create methods.
Example: create a TCPIPConnection with name "TCPIPConnection_Object", in repository "AAAAAAAA".

     // create a store to contain your objects for this change. If you do not have an existing object
     // or store to use.  You may obtain the store from another object by using Object.getObjectStore().
     MdFactory factory; //where "factory" is a valid MdFactory instance
     MdObjectStore objectStore = factory.createObjectStore();
     TCPIPConnection myObject = (TCPIPConnection) factory.createComplexMetadataObject(objectStore, "TCPIPConnection_Object", MetadataObjects.TCPIPCONNECTION, "AAAAAAAA");
     myObject.updateMetadataAll();  // Write object to server
     objectStore.dispose();  // dispose of the object store if it is no longer needed

## Behavior

- Attributes and associations for this object can be retrieved by using the methods in `MdOMIUtil`.
- When changes are made to the object, either by setting an attribute or adding objects to a particular association, they can be persisted to the metadata server with the `updateMetadataAll` method.
- If an object needs to be deleted, the `delete` method can be used. This will flag the object as being deleted on the client, and will require an update call to persist the change to the server.

## Dependencies

This class depends on objects being contained in an MdObjectStore. Object stores should be disposed of when they are no longer needed as this will help clean up memory. Disposing an object store will dispose of all objects contained within that store.

Since:
  9.0

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final String`
  `ATTRIBUTE_HOSTNAME_NAME`
  Constant used for the name of the HostName attribute.
  `static final String`
  `ATTRIBUTE_PORT_NAME`
  Constant used for the name of the Port attribute.
  `static final String`
  `ATTRIBUTE_SERVICE_NAME`
  Constant used for the name of the Service attribute.

  ### Fields inherited from interface com.sas.metadata.remote.Connection

  `ASSOCIATION_DATASOURCES_NAME, ASSOCIATION_DOMAIN_NAME, ASSOCIATION_PASSTHRUPASSWORD_NAME, ASSOCIATION_PROVIDERS_NAME, ASSOCIATION_SAPW_NAME, ASSOCIATION_SOURCE_NAME, ATTRIBUTE_APPLICATIONPROTOCOL_NAME, ATTRIBUTE_AUTHENTICATIONTYPE_NAME, ATTRIBUTE_COMMUNICATIONPROTOCOL_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.ContentLocation

  `ASSOCIATION_ASSOCIATEDCONTENTTYPE_NAME, ASSOCIATION_FILEREFS_NAME, ASSOCIATION_REPORTS_NAME, ASSOCIATION_TSASSOCIATEDNAMESPACE_NAME, ASSOCIATION_UNITOFTIMES_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.DeployedDataPackage

  `ASSOCIATION_ALIASES_NAME, ASSOCIATION_ALIASFOR_NAME, ASSOCIATION_DEPLOYEDCOMPONENTS_NAME, ASSOCIATION_TABLECOLLECTIONS_NAME, ASSOCIATION_USEDBYPACKAGES_NAME, ASSOCIATION_USINGPACKAGES_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.MdObjectBase

  `ATTRIBUTE_DESC_NAME, ATTRIBUTE_ID_NAME, ATTRIBUTE_METADATACREATED_NAME, ATTRIBUTE_METADATAUPDATED_NAME, ATTRIBUTE_NAME_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.PrimaryType

  `ASSOCIATION_FAVORITESCONTAINERS_NAME, ATTRIBUTE_ISHIDDEN_NAME, ATTRIBUTE_PUBLICTYPE_NAME`

  ### Fields inherited from interface com.sas.metadata.remote.Root

  `ASSOCIATION_ACCESSCONTROLS_NAME, ASSOCIATION_CHANGES_NAME, ASSOCIATION_CUSTOMASSOCIATIONS_NAME, ASSOCIATION_DOCUMENTS_NAME, ASSOCIATION_EXTENSIONS_NAME, ASSOCIATION_EXTERNALIDENTITIES_NAME, ASSOCIATION_GROUPS_NAME, ASSOCIATION_IMPLEMENTORS_NAME, ASSOCIATION_KEYWORDS_NAME, ASSOCIATION_LOCALIZEDATTRIBUTES_NAME, ASSOCIATION_NOTES_NAME, ASSOCIATION_PRIMARYPROPERTYGROUP_NAME, ASSOCIATION_PROMPTS_NAME, ASSOCIATION_PROPERTIES_NAME, ASSOCIATION_PROPERTYSETS_NAME, ASSOCIATION_REFERENCEDOBJECTS_NAME, ASSOCIATION_RESPONSIBLEPARTIES_NAME, ASSOCIATION_SOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECSOURCETRANSFORMATIONS_NAME, ASSOCIATION_SPECTARGETTRANSFORMATIONS_NAME, ASSOCIATION_TARGETTRANSFORMATIONS_NAME, ASSOCIATION_TIMESTAMPS_NAME, ASSOCIATION_TREES_NAME, ASSOCIATION_TSOBJECTNAMESPACE_NAME, ASSOCIATION_USEDBYPROTOTYPES_NAME, ASSOCIATION_USINGPROTOTYPE_NAME, ASSOCIATION_VARIABLES_NAME, ATTRIBUTE_CHANGESTATE_NAME, ATTRIBUTE_LOCKEDBY_NAME, ATTRIBUTE_USAGEVERSION_NAME`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `String`
  `getHostName()`
  Gets the `String` value of `HostName`
  `int`
  `getHostNameMaxLength()`
  Gets the maximum length of `HostName`
  `int`
  `getHostNameState()`
  Gets the Metadata State of `HostName`
  `int`
  `getPort()`
  Gets the `int` value of `Port`
  `int`
  `getPortState()`
  Gets the Metadata State of `Port`
  `String`
  `getService()`
  Gets the `String` value of `Service`
  `int`
  `getServiceMaxLength()`
  Gets the maximum length of `Service`
  `int`
  `getServiceState()`
  Gets the Metadata State of `Service`
  `void`
  `initializePredObjects()`
  (S) Adds the Associated objects to the predObjects which are:
  `void`
  `initializeRequiredObjects()`
  (S) This initializes the Required Objects(Roles) which are:
  `void`
  `setHostName(String inHostName)`
  Sets the `HostName` value and sets the state to MetadataState.LOCAL.
  `void`
  `setHostName(String inHostName, int state)`
  Sets the `HostName` Metadata State.
  `void`
  `setHostNameState(int state)`
  Sets the Metadata State of `HostName`.
  `void`
  `setPort(int inPort)`
  Sets the `Port` value and sets the state to MetadataState.LOCAL.
  `void`
  `setPort(int inPort, int state)`
  Sets the `Port` Metadata State.
  `void`
  `setPort(String inPort)`
  Sets the `Port` value and sets the state to MetadataState.LOCAL.
  `void`
  `setPort(String inPort, int state)`
  Sets the `Port` value and Metadata State.
  `void`
  `setPortState(int state)`
  Sets the Metadata State of `Port`.
  `void`
  `setService(String inService)`
  Sets the `Service` value and sets the state to MetadataState.LOCAL.
  `void`
  `setService(String inService, int state)`
  Sets the `Service` Metadata State.
  `void`
  `setServiceState(int state)`
  Sets the Metadata State of `Service`.

  ### Methods inherited from interface com.sas.metadata.remote.Connection

  `getApplicationProtocol, getApplicationProtocolMaxLength, getApplicationProtocolState, getAuthenticationType, getAuthenticationTypeMaxLength, getAuthenticationTypeState, getCommunicationProtocol, getCommunicationProtocolMaxLength, getCommunicationProtocolState, getDataSources, getDataSources, getDomain, getDomains, getDomains, getPassthruPassword, getPassthruPasswords, getPassthruPasswords, getProviders, getProviders, getSAPW, getSAPWs, getSAPWs, getSource, getSources, getSources, setApplicationProtocol, setApplicationProtocol, setApplicationProtocolState, setAuthenticationType, setAuthenticationType, setAuthenticationTypeState, setCommunicationProtocol, setCommunicationProtocol, setCommunicationProtocolState, setDataSources, setDataSources, setDomain, setDomains, setDomains, setPassthruPassword, setPassthruPasswords, setPassthruPasswords, setProviders, setProviders, setSAPW, setSAPWs, setSAPWs, setSource, setSources, setSources`

  ### Methods inherited from interface com.sas.metadata.remote.ContentLocation

  `getAssociatedContentType, getAssociatedContentTypes, getAssociatedContentTypes, getFileRefs, getFileRefs, getReports, getReports, getTSAssociatedNamespace, getTSAssociatedNamespaces, getTSAssociatedNamespaces, getUnitofTimes, getUnitofTimes, setAssociatedContentType, setAssociatedContentTypes, setAssociatedContentTypes, setFileRefs, setFileRefs, setReports, setReports, setTSAssociatedNamespace, setTSAssociatedNamespaces, setTSAssociatedNamespaces, setUnitofTimes, setUnitofTimes`

  ### Methods inherited from interface com.sas.metadata.remote.DeployedDataPackage

  `getAliases, getAliases, getAliasFor, getAliasFors, getAliasFors, getDeployedComponents, getDeployedComponents, getTableCollections, getTableCollections, getUsedByPackages, getUsedByPackages, getUsingPackages, getUsingPackages, setAliases, setAliases, setAliasFor, setAliasFors, setAliasFors, setDeployedComponents, setDeployedComponents, setTableCollections, setTableCollections, setUsedByPackages, setUsedByPackages, setUsingPackages, setUsingPackages`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBase

  `addElementToChangeList, clearChangeList, getChangeList, getCMetadataType, getDesc, getDescMaxLength, getDescState, getFQID, getId, getIdState, getMetadataCreated, getMetadataCreatedState, getMetadataUpdated, getMetadataUpdatedState, getName, getNameMaxLength, getNameState, getObjectStore, getPredAssociations, getRepositoryID, getRequiredAssociations, getState, isAssociationRequired, isNewObject, isPredAssociation, removeElementFromChangeList, resetObject, resetState, resetStates, setCMetadataType, setDesc, setDesc, setDescState, setFQID, setFQID, setId, setId, setIdState, setMetadataCreated, setMetadataCreated, setMetadataCreatedState, setMetadataUpdated, setMetadataUpdated, setMetadataUpdatedState, setName, setName, setNameState, setObjectStore, setState`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseUtil

  `addMdObjectListener, delete, dispose, fireMdObjectModified, getAssociatedObjects, getAssociatedObjects, getAssociatedObjects, getAssociationNames, getAssocs, getAssocsWA, getAttributeNames, getAttrs, getAttrsStates, getAuthorizationUtil, getChangeManagementState, getChgMgtExternalIdentityImportType, getClientSideOnlyObject, getMdObjectAssociation, getPopulatedAssocs, getUpdatedAttrs, getViewList, isCheckedOut, isLocked, objectModified, removeMdObjectListener, setAttrs, setChangeManagementTargetRepository, setChgMgtExternalIdentityImportType, setClientSideOnlyObject, setMdObjectAssociation, touch, updateAssnsIds`

  ### Methods inherited from interface com.sas.metadata.remote.MdObjectBaseXML

  `closeUpdateMetadataXML, createEmptyXML, createObjectRefreshXML, createObjectXML, createObjectXML, createUpdateAssociationXML, createUpdateAssociationXML, createUpdateSimpleXML, doCreateUpdateXML, getUpdateSimpleSubstring, updateMetadataAll`

  ### Methods inherited from interface com.sas.metadata.remote.PrimaryType

  `getFavoritesContainers, getFavoritesContainers, getIsHidden, getIsHiddenState, getPublicType, getPublicTypeMaxLength, getPublicTypeState, setFavoritesContainers, setFavoritesContainers, setIsHidden, setIsHidden, setIsHidden, setIsHidden, setIsHiddenState, setPublicType, setPublicType, setPublicTypeState`

  ### Methods inherited from interface com.sas.metadata.remote.Root

  `getAccessControls, getAccessControls, getChanges, getChanges, getChangeState, getChangeStateMaxLength, getChangeStateState, getCustomAssociations, getCustomAssociations, getDocuments, getDocuments, getExtensions, getExtensions, getExternalIdentities, getExternalIdentities, getGroups, getGroups, getImplementors, getImplementors, getKeywords, getKeywords, getLocalizedAttributes, getLocalizedAttributes, getLockedBy, getLockedByMaxLength, getLockedByState, getNotes, getNotes, getPrimaryPropertyGroup, getPrimaryPropertyGroups, getPrimaryPropertyGroups, getPrompts, getPrompts, getProperties, getProperties, getPropertySets, getPropertySets, getReferencedObjects, getReferencedObjects, getResponsibleParties, getResponsibleParties, getSourceTransformations, getSourceTransformations, getSpecSourceTransformations, getSpecSourceTransformations, getSpecTargetTransformations, getSpecTargetTransformations, getTargetTransformations, getTargetTransformations, getTimestamps, getTimestamps, getTrees, getTrees, getTSObjectNamespace, getTSObjectNamespaces, getTSObjectNamespaces, getUsageVersion, getUsageVersionState, getUsedByPrototypes, getUsedByPrototypes, getUsingPrototype, getUsingPrototypes, getUsingPrototypes, getVariables, getVariables, setAccessControls, setAccessControls, setChanges, setChanges, setChangeState, setChangeState, setChangeStateState, setCustomAssociations, setCustomAssociations, setDocuments, setDocuments, setExtensions, setExtensions, setExternalIdentities, setExternalIdentities, setGroups, setGroups, setImplementors, setImplementors, setKeywords, setKeywords, setLocalizedAttributes, setLocalizedAttributes, setLockedBy, setLockedBy, setLockedByState, setNotes, setNotes, setPrimaryPropertyGroup, setPrimaryPropertyGroups, setPrimaryPropertyGroups, setPrompts, setPrompts, setProperties, setProperties, setPropertySets, setPropertySets, setReferencedObjects, setReferencedObjects, setResponsibleParties, setResponsibleParties, setSourceTransformations, setSourceTransformations, setSpecSourceTransformations, setSpecSourceTransformations, setSpecTargetTransformations, setSpecTargetTransformations, setTargetTransformations, setTargetTransformations, setTimestamps, setTimestamps, setTrees, setTrees, setTSObjectNamespace, setTSObjectNamespaces, setTSObjectNamespaces, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersion, setUsageVersionState, setUsedByPrototypes, setUsedByPrototypes, setUsingPrototype, setUsingPrototypes, setUsingPrototypes, setVariables, setVariables`

- ## Field Details

  - ### ATTRIBUTE_HOSTNAME_NAME

    static final String ATTRIBUTE_HOSTNAME_NAME
    Constant used for the name of the HostName attribute.

    HostName: This is the IP name or IP address used to connect to a deployed component.

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_SERVICE_NAME

    static final String ATTRIBUTE_SERVICE_NAME
    Constant used for the name of the Service attribute.

    Service: The name of the service to use when connecting to a server.

    See Also:
      - Constant Field Values

  - ### ATTRIBUTE_PORT_NAME

    static final String ATTRIBUTE_PORT_NAME
    Constant used for the name of the Port attribute.

    Port: The port number to use to connect to the server.

    See Also:
      - Constant Field Values

- ## Method Details

  - ### initializeRequiredObjects

    void initializeRequiredObjects() throws RemoteException
    (S) This initializes the Required Objects(Roles) which are:
    Specified by:
      `initializeRequiredObjects` in interface `Connection`
    Specified by:
      `initializeRequiredObjects` in interface `ContentLocation`
    Specified by:
      `initializeRequiredObjects` in interface `DeployedDataPackage`
    Specified by:
      `initializeRequiredObjects` in interface `MdObjectBaseUtil`
    Specified by:
      `initializeRequiredObjects` in interface `OpenClientConnection`
    Specified by:
      `initializeRequiredObjects` in interface `PrimaryType`
    Specified by:
      `initializeRequiredObjects` in interface `Root`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### initializePredObjects

    void initializePredObjects() throws RemoteException
    (S) Adds the Associated objects to the predObjects which are:
    Specified by:
      `initializePredObjects` in interface `Connection`
    Specified by:
      `initializePredObjects` in interface `ContentLocation`
    Specified by:
      `initializePredObjects` in interface `DeployedDataPackage`
    Specified by:
      `initializePredObjects` in interface `MdObjectBase`
    Specified by:
      `initializePredObjects` in interface `OpenClientConnection`
    Specified by:
      `initializePredObjects` in interface `PrimaryType`
    Specified by:
      `initializePredObjects` in interface `Root`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getHostName

    String getHostName() throws RemoteException
    Gets the `String` value of `HostName`
    Returns:
      The `HostName`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getHostNameState

    int getHostNameState() throws RemoteException
    Gets the Metadata State of `HostName`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getHostNameMaxLength

    int getHostNameMaxLength() throws RemoteException
    Gets the maximum length of `HostName`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getService

    String getService() throws RemoteException
    Gets the `String` value of `Service`
    Returns:
      The `Service`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getServiceState

    int getServiceState() throws RemoteException
    Gets the Metadata State of `Service`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getServiceMaxLength

    int getServiceMaxLength() throws RemoteException
    Gets the maximum length of `Service`
    Returns:
      The max size
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getPort

    int getPort() throws RemoteException
    Gets the `int` value of `Port`
    Returns:
      The `Port`
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### getPortState

    int getPortState() throws RemoteException
    Gets the Metadata State of `Port`
    Returns:
      The State.
    Throws:
      `RemoteException` - If error connecting/communicating to/with remote object.

  - ### setHostName

    void setHostName(String inHostName) throws RemoteException
    Sets the `HostName` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inHostName` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setHostName

    void setHostName(String inHostName, int state) throws RemoteException
    Sets the `HostName` Metadata State.
    Parameters:
      `inHostName` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setHostNameState

    void setHostNameState(int state) throws RemoteException
    Sets the Metadata State of `HostName`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setService

    void setService(String inService) throws RemoteException
    Sets the `Service` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inService` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setService

    void setService(String inService, int state) throws RemoteException
    Sets the `Service` Metadata State.
    Parameters:
      `inService` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setServiceState

    void setServiceState(int state) throws RemoteException
    Sets the Metadata State of `Service`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setPort

    void setPort(int inPort) throws RemoteException
    Sets the `Port` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inPort` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setPort

    void setPort(int inPort, int state) throws RemoteException
    Sets the `Port` Metadata State.
    Parameters:
      `inPort` - int
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setPort

    void setPort(String inPort) throws RemoteException
    Sets the `Port` value and sets the state to MetadataState.LOCAL.
    Parameters:
      `inPort` - String
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setPort

    void setPort(String inPort, int state) throws RemoteException
    Sets the `Port` value and Metadata State.
    Parameters:
      `inPort` - String
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.

  - ### setPortState

    void setPortState(int state) throws RemoteException
    Sets the Metadata State of `Port`.
    Parameters:
      `state` - int
    Throws:
      `RemoteException` - If error communicating with remote object.